from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	i= Int('i')
	array= DeclareSort('array')
	senders= Const('senders',array)
	array_length= Function('array_length',array,IntSort())
	address= DeclareSort('address')
	d1Taddressarray= Function('d1Taddressarray',array,IntSort(),address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	TUPLE= DeclareSort('TUPLE')
	TUPLE_0= Const('TUPLE_0',TUPLE)
	LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
	sent= Const('sent',BoolSort())
	UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
	_2solidity= Const('_2solidity',void)
	_1reentrancy_verifier= Int('_1reentrancy_verifier')
	_2reentrancy_verifier= Int('_2reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	i1= Int('i1')
	senders1= Const('senders1',array)
	array_length1= Function('array_length1',array,IntSort())
	d1Taddressarray1= Function('d1Taddressarray1',array,IntSort(),address)
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	bal1= Int('bal1')
	_1solidity1= Const('_1solidity1',void)
	TUPLE_01= Const('TUPLE_01',TUPLE)
	LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
	sent1= Const('sent1',BoolSort())
	UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
	_2solidity1= Const('_2solidity1',void)
	_1reentrancy_verifier1= Int('_1reentrancy_verifier1')
	_2reentrancy_verifier1= Int('_2reentrancy_verifier1')
	i8= Function('i8',IntSort(),IntSort(),IntSort())
	d1FaddressTuint256mapping8= Function('d1FaddressTuint256mapping8',map,address,IntSort(),IntSort(),IntSort())
	bal8= Function('bal8',IntSort(),IntSort(),IntSort())
	TUPLE_08= Function('TUPLE_08',IntSort(),IntSort(),TUPLE)
	sent8= Function('sent8',IntSort(),IntSort(),BoolSort())
	_2reentrancy_verifier8= Function('_2reentrancy_verifier8',IntSort(),IntSort(),IntSort())
	i18= Function('i18',IntSort(),IntSort())
	d1FaddressTuint256mapping18= Function('d1FaddressTuint256mapping18',map,address,IntSort(),IntSort())
	TUPLE_018= Function('TUPLE_018',IntSort(),TUPLE)
	sent18= Function('sent18',IntSort(),BoolSort())
	_2reentrancy_verifier18= Function('_2reentrancy_verifier18',IntSort(),IntSort())
	bal18= Function('bal18',IntSort(),IntSort())
	_1reentrancy_verifier18= Function('_1reentrancy_verifier18',IntSort(),IntSort())
	_y1= Const('_y1',CONRT_EtherStore)
	_y2= Const('_y2',array)
	_y3= Const('_y3',array)
	_y4= Int('_y4')
	_y5= Const('_y5',address)
	_y6= Int('_y6')
	_y7= Const('_y7',TUPLE)
	_y8= Int('_y8')
	_y9= Const('_y9',map)
	_y10= Const('_y10',address)
	_y11= Const('_y11',CONRT_EtherStore)
	_n1= Int('_n1')
	_n2= Int('_n2')
	_y12= Const('_y12',map)
	_y13= Const('_y13',address)
	_y14= Const('_y14',CONRT_EtherStore)
	_y15= Const('_y15',CONRT_EtherStore)
	_y16= Const('_y16',CONRT_EtherStore)
	_y17= Const('_y17',CONRT_EtherStore)
	_y18= Const('_y18',CONRT_EtherStore)
	_y19= Const('_y19',map)
	_y20= Const('_y20',address)
	_y21= Const('_y21',CONRT_EtherStore)
	_y22= Const('_y22',CONRT_EtherStore)
	_N1= Function('_N1',IntSort(),IntSort())
	_y23= Const('_y23',CONRT_EtherStore)
	_y24= Const('_y24',map)
	_y25= Const('_y25',address)
	_y26= Const('_y26',CONRT_EtherStore)
	_y27= Const('_y27',CONRT_EtherStore)
	_y28= Const('_y28',CONRT_EtherStore)
	_y29= Const('_y29',CONRT_EtherStore)
	_y30= Const('_y30',CONRT_EtherStore)
	_y31= Const('_y31',CONRT_EtherStore)
	_y32= Const('_y32',map)
	_y33= Const('_y33',address)
	_N2= Int('_N2')
	_y34= Const('_y34',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y1],EtherStore_balances1(_y1)==EtherStore_balances(_y1)))
	_s.add(senders1==senders)
	_s.add(ForAll([_y2],array_length1(_y2)==array_length(_y2)))
	_s.add(ForAll([_y3,_y4],d1Taddressarray1(_y3,_y4)==d1Taddressarray(_y3,_y4)))
	_s.add(_1solidity1==_1solidity)
	_s.add(ForAll([_y5,_y6],LOW_LEVEL_CALL_call1(_y5,_y6)==LOW_LEVEL_CALL_call(_y5,_y6)))
	_s.add(ForAll([_y7,_y8],UNPACK2DTUPLETbool1(_y7,_y8)==UNPACK2DTUPLETbool(_y7,_y8)))
	_s.add(_2solidity1==_2solidity)
	_s.add(i1==i18(_N2))
	_s.add(ForAll([_y9,_y10],d1FaddressTuint256mapping1(_y9,_y10)==d1FaddressTuint256mapping18(_y9,_y10,_N2)))
	_s.add(bal1==bal18(_N2))
	_s.add(TUPLE_01==TUPLE_018(_N2))
	_s.add(sent1==sent18(_N2))
	_s.add(_1reentrancy_verifier1==_1reentrancy_verifier18(_N2))
	_s.add(_2reentrancy_verifier1==_2reentrancy_verifier18(_N2))
	_s.add(ForAll([_n2,_n1,_y11,_n1,_n2],Implies(And(_n2>=0,_n1>=0),i8(_n1 + 1,_n2)==If(((d1FaddressTuint256mapping8(EtherStore_balances(_y11),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))>(0)),If(((UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_n1,_n2)),d1FaddressTuint256mapping8(EtherStore_balances(_y11),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2)),0))==(True)),i8(_n1, _n2) + 1,i8(_n1, _n2)),i8(_n1, _n2)))))
	_s.add(ForAll([_n2,_n1,_y12,_y13,_y14,_n1,_n2],Implies(And(_n2>=0,_n1>=0),d1FaddressTuint256mapping8(_y12,_y13,_n1 + 1,_n2)==If(((d1FaddressTuint256mapping8(EtherStore_balances(_y14),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))>(0)),If(And(((_y12)==(EtherStore_balances(_y14))),((_y13)==(d1Taddressarray(senders,i8(_n1,_n2))))),0,d1FaddressTuint256mapping8(_y12,_y13,_n1,_n2)),d1FaddressTuint256mapping8(_y12,_y13,_n1,_n2)))))
	_s.add(ForAll([_n2,_n1,_y15,_n1,_n2],Implies(And(_n2>=0,_n1>=0),bal8(_n1 + 1,_n2)==d1FaddressTuint256mapping8(EtherStore_balances(_y15),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))))
	_s.add(ForAll([_n2,_n1,_y16,_n1,_n2],Implies(And(_n2>=0,_n1>=0),TUPLE_08(_n1 + 1,_n2)==If(((d1FaddressTuint256mapping8(EtherStore_balances(_y16),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))>(0)),LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_n1,_n2)),d1FaddressTuint256mapping8(EtherStore_balances(_y16),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2)),TUPLE_08(_n1,_n2)))))
	_s.add(ForAll([_n2,_n1,_y17,_n1,_n2],Implies(And(_n2>=0,_n1>=0),sent8(_n1 + 1,_n2)==If(((d1FaddressTuint256mapping8(EtherStore_balances(_y17),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_n1,_n2)),d1FaddressTuint256mapping8(EtherStore_balances(_y17),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2)),0),sent8(_n1,_n2)))))
	_s.add(ForAll([_n2,_n1,_y18,_n1,_n2],Implies(And(_n2>=0,_n1>=0),_2reentrancy_verifier8(_n1 + 1,_n2)==If(((d1FaddressTuint256mapping8(EtherStore_balances(_y18),d1Taddressarray(senders,i8(_n1,_n2)),_n1,_n2))>(0)),1,_2reentrancy_verifier8(_n1,_n2)))))
	_s.add(ForAll([_n2,_n2],Implies(_n2>=0,i8(0,_n2)==0)))
	_s.add(ForAll([_n2,_y19,_y20,_y21,_n2],Implies(_n2>=0,d1FaddressTuint256mapping8(_y19,_y20,0,_n2)==If(And(((_y19)==(EtherStore_balances(_y21))),((_y20)==(d1Taddressarray(senders,i18(_n2))))),0,d1FaddressTuint256mapping18(_y19,_y20,_n2)))))
	_s.add(ForAll([_n2,_y22,_n2],Implies(_n2>=0,bal8(0,_n2)==d1FaddressTuint256mapping18(EtherStore_balances(_y22),d1Taddressarray(senders,i18(_n2)),_n2))))
	_s.add(ForAll([_n2,_n2],Implies(_n2>=0,TUPLE_08(0,_n2)==TUPLE_018(_n2))))
	_s.add(ForAll([_n2,_n2],Implies(_n2>=0,sent8(0,_n2)==sent18(_n2))))
	_s.add(ForAll([_n2,_n2],Implies(_n2>=0,_2reentrancy_verifier8(0,_n2)==_2reentrancy_verifier18(_n2))))
	_s.add(ForAll([_n2],Implies(_n2>=0,((((i8(_N1(_n2), _n2))>=(array_length(senders))))!=(True)))))
	_s.add(ForAll([_n2,_n1,_n1],Implies(And(_n2>=0,_n1>=0),Implies(_n1 < _N1(_n2),((((i8(_n1, _n2))<(array_length(senders))))==(True))))))
	_s.add(ForAll([_n2],Implies(_n2>=0,_N1(_n2) >= 0)))
	_s.add(ForAll([_n2,_y23,_n2],Implies(_n2>=0,i18(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y23),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),If(((UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_N1(_n2),_n2)),bal8(_N1(_n2),_n2)),0))==(True)),i8(_N1(_n2), _n2) + 1,i8(_N1(_n2), _n2)),i18(_n2)))))
	_s.add(ForAll([_n2,_y24,_y25,_y26,_n2],Implies(_n2>=0,d1FaddressTuint256mapping18(_y24,_y25,_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y26),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),d1FaddressTuint256mapping8(_y24,_y25,_N1(_n2),_n2),d1FaddressTuint256mapping18(_y24,_y25,_n2)))))
	_s.add(ForAll([_n2,_y27,_n2],Implies(_n2>=0,bal18(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y27),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),bal8(_N1(_n2), _n2),d1FaddressTuint256mapping18(EtherStore_balances(_y27),d1Taddressarray(senders,i18(_n2)),_n2)))))
	_s.add(ForAll([_n2,_y28,_n2],Implies(_n2>=0,TUPLE_018(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y28),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_N1(_n2),_n2)),bal8(_N1(_n2),_n2)),TUPLE_018(_n2)))))
	_s.add(ForAll([_n2,_y29,_n2],Implies(_n2>=0,sent18(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y29),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(d1Taddressarray(senders,i8(_N1(_n2),_n2)),bal8(_N1(_n2),_n2)),0),sent18(_n2)))))
	_s.add(ForAll([_n2,_y30,_n2],Implies(_n2>=0,_1reentrancy_verifier18(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y30),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),1,_1reentrancy_verifier18(_n2)))))
	_s.add(ForAll([_n2,_y31,_n2],Implies(_n2>=0,_2reentrancy_verifier18(_n2 + 1)==If(((d1FaddressTuint256mapping18(EtherStore_balances(_y31),d1Taddressarray(senders,i18(_n2)),_n2))>(0)),_2reentrancy_verifier8(_N1(_n2),_n2),_2reentrancy_verifier18(_n2)))))
	_s.add(i18(0)==0)
	_s.add(ForAll([_y32,_y33],d1FaddressTuint256mapping18(_y32,_y33,0)==d1FaddressTuint256mapping(_y32,_y33)))
	_s.add(bal18(0)==bal)
	_s.add(TUPLE_018(0)==TUPLE_0)
	_s.add(sent18(0)==sent)
	_s.add(_1reentrancy_verifier18(0)==0)
	_s.add(_2reentrancy_verifier18(0)==0)
	_s.add(((((i18(_N2))>=(array_length(senders))))!=(True)))
	_s.add(ForAll([_n2,_n2],Implies(_n2>=0,Implies(_n2 < _N2,((((i18(_n2))<(array_length(senders))))==(True))))))
	_s.add(_N2 >= 0)
	_s.add(ForAll([_n2],Implies(_n2>=0,((_N1(_n2))==(2)))))
	_s.add(((_N2)==(2)))
	_s.add(ForAll([_n2,_y34],Implies(_n2>=0,((d1FaddressTuint256mapping18(EtherStore_balances(_y34),d1Taddressarray(senders,i18(_n2)),_n2))>(0)))))
	_s.add(Not(And((_1reentrancy_verifier1==1),(_2reentrancy_verifier1==0))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)